
//+------------------------------------------------------------------+
//|                                              Ish_03_DayRange.mq4 |
//|                                   Copyright  2007,Sartakov S.D. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007,Sartakov S.D."
#property link      "mailto:ssd@dp.ukrtel.net"
#include <stderror.mqh>
#include <stdlib.mqh>
#include <WinUser32.mqh>
#include "DayRange_Data_Open.mq4"
#include <Lite_EXPERT1.mqh>

//+------------------------------------------------------------------+
extern int MagicNumber_1  =111;     
extern int MagicNumber_2  =222;        

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   init_DayRange();
//----   
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
    deinit_DayRange();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   start_DayRange();
   
   static int MagicOpen = 0 ;
   MagicOpen++; if (MagicOpen == MagicNumber_1) MagicOpen++; if (MagicOpen == MagicNumber_2) MagicOpen++; 
   if (BUY)
    if(OpenBuyOrder1 (BUY, MagicOpen, Money_Management,STOPLOSS, TAKEPROFIT)) PlaySound("ok.wav");
    else PlaySound("alert.wav");

   MagicOpen++; if (MagicOpen == MagicNumber_1) MagicOpen++; if (MagicOpen == MagicNumber_2) MagicOpen++; 
   if (BUYLIMIT)
    if(OpenBuyLimitOrder1(BUYLIMIT,MagicOpen,Money_Management,STOPLOSS,TAKEPROFIT,BUYLIMIT_LEVEL,0)) PlaySound("ok.wav");
    else PlaySound("alert.wav");
    
    
   MagicOpen++; if (MagicOpen == MagicNumber_1) MagicOpen++; if (MagicOpen == MagicNumber_2) MagicOpen++; 
   if (SELL)
    if (OpenSellOrder1(SELL,MagicOpen, Money_Management,STOPLOSS, TAKEPROFIT))PlaySound("ok.wav");
    else PlaySound("alert.wav");

   MagicOpen++; if (MagicOpen == MagicNumber_1) MagicOpen++; if (MagicOpen == MagicNumber_2) MagicOpen++; 
   if (SELLIMIT)
    if(OpenSellLimitOrder1 (SELLIMIT,MagicOpen,Money_Management,STOPLOSS,TAKEPROFIT,SELLLIMIT_LEVEL,0)) PlaySound("ok.wav");
    else PlaySound("alert.wav");
    
//----
   return(0); //   
  }
//+------------------------------------------------------------------+

int init_DayRange()
{
DayPrevtime=Time[0];


DayMax=MarketInfo(Symbol(),MODE_HIGH); if (DayMax == 0) DayMax = High[0];
DayMin=MarketInfo(Symbol(),MODE_LOW);  if (DayMin == 0) DayMin = Low[0];
DayMid=DayMin+(DayMax-DayMin)/2;
DayChanW=(DayMax-DayMin)/Point;
DayChanD= NormalizeDouble((iMA(Symbol(), PERIOD_D1,DayNumber, 0, MODE_SMA, PRICE_HIGH, 1)
          -iMA(Symbol(), PERIOD_D1,DayNumber, 0, MODE_SMA, PRICE_LOW, 1))/Point,0);

String = "yyyy.mm.dd hh:mi";
String = TimeToStr(TimeCurrent());

String = StringSetChar(String,11,'0'); //hh
String = StringSetChar(String,12,'0');

String = StringSetChar(String,14,'0'); //mi
String = StringSetChar(String,15,'0');
DayStart   = StrToTime(String); 
DayEnd     = DayStart+86400;
RangeStartPrev = RangeStart;
RangeStart     = DayStart-86400;
if (TimeDayOfWeek(RangeStart) == 0) RangeStart = RangeStart-2*86400; //  ...
if (TimeDayOfWeek(RangeStart) == 6) RangeStart = RangeStart-1*86400; //  ...
RangeMax = iHigh(NULL,0,iHighest(NULL,0,MODE_HIGH,iBarShift(NULL,0,RangeStart,false)-iBarShift(NULL,0,DayStart,false),iBarShift(NULL,0,DayStart,false)));
RangeMin = iLow (NULL,0,iLowest (NULL,0,MODE_LOW ,iBarShift(NULL,0,RangeStart,false)-iBarShift(NULL,0,DayStart,false),iBarShift(NULL,0,DayStart,false)));
RangeMid = RangeMin+(RangeMax-RangeMin)/2;
RangeChanW=(RangeMax-RangeMin)/Point;

String = StringSetChar(String,11,'0'); //hh
String = StringSetChar(String,12,'7');
String = StringSetChar(String,14,'0'); //mi
String = StringSetChar(String,15,'0');

EurSesStart = StrToTime(String);

String = StringSetChar(String,11,'1'); //hh
String = StringSetChar(String,12,'4');
String = StringSetChar(String,14,'0'); //mi
String = StringSetChar(String,15,'0');

UsaSesStart = StrToTime(String);


String = StringSetChar(String,11,'2'); //hh
String = StringSetChar(String,12,'2');
String = StringSetChar(String,14,'5'); //mi
String = StringSetChar(String,15,'0');

TradeEnd = StrToTime(String);

 
DayChanCreate();
 
//----
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit_DayRange()
  {
   ObjectsDeleteAll(EMPTY,OBJ_HLINE);
   ObjectsDeleteAll(EMPTY,OBJ_VLINE);

   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

int start_DayRange()
{ 
     if (DayMax < High[0])
      {
        DayMax = High[0];  
        DayMid=DayMin+(DayMax-DayMin)/2;
        DayChanW=(DayMax-DayMin)/Point;
        DayChanMove();
      }
     if (DayMin > Low[0])
      {
        DayMin = Low[0]; 
        DayMid=DayMin+(DayMax-DayMin)/2;
        DayChanW=(DayMax-DayMin)/Point;
        DayChanMove();
      }
     DayMove=(Bid-Open[0])/Point;
     DayMoveDis();  
     if (RangeStartPrev != D'2008.01.01 00:00:00')
      {
RangeMax = iHigh(NULL,0,iHighest(NULL,0,MODE_HIGH,iBarShift(NULL,0,RangeStartPrev,false)-iBarShift(NULL,0,DayStart,false),iBarShift(NULL,0,DayStart,false)));
RangeMin = iLow (NULL,0,iLowest (NULL,0,MODE_LOW ,iBarShift(NULL,0,RangeStartPrev,false)-iBarShift(NULL,0,DayStart,false),iBarShift(NULL,0,DayStart,false)));
RangeMid = RangeMin+(RangeMax-RangeMin)/2;
RangeChanW=(RangeMax-RangeMin)/Point;
ObjectMove("RangeMax"           , 0,D'2007.05.01 00:00:00'      ,RangeMax);
ObjectMove("RangeMin"           , 0,D'2007.05.01 00:00:00'      ,RangeMin);
ObjectMove("RangeMid"           , 0,D'2007.05.01 00:00:00'      ,RangeMid);
ObjectMove("RangeStart"         , 0,RangeStartPrev      ,0);
       }

     if (DayPrevtime==Time[0]) return;
     DayPrevtime=Time[0];

   ObjectMove("DayMaxFix" , 0,D'2007.05.01 00:00:00'      ,DayMax);
   ObjectMove("DayMinFix" , 0,D'2007.05.01 00:00:00'      ,DayMin);
   ObjectMove("DayMidFix" , 0,D'2007.05.01 00:00:00'      ,DayMid);
return(0);
}
//+------------------------------------------------------------------+

int DayMoveDis( )
  {
if (RangeStartPrev == D'2008.01.01 00:00:00') datetime temp = RangeStart; else temp = RangeStartPrev;
    Comment("\n"+DayNumber+" PastDayRange/CurrentDayRange= "+DoubleToStr(DayChanD,0)+" / "+DoubleToStr(DayChanW,0)
           ,"\n"+TimeToStr(temp,TIME_DATE)+" - "+TimeToStr(DayStart,TIME_DATE)+" H / L / R = "+DoubleToStr(RangeMax,4)
                +" / "+DoubleToStr(RangeMin,4)+" / "+DoubleToStr(RangeChanW,0));
   return;           
  }
//+------------------------------------------------------------------+
 
int  DayChanCreate()
{
   ObjectCreate("DayMax"         ,OBJ_HLINE,0,D'2007.05.01 00:00:00'      ,DayMax);
   ObjectCreate("DayMin"         ,OBJ_HLINE,0,D'2007.05.01 00:00:00'      ,DayMin);
   ObjectCreate("DayMid"         ,OBJ_HLINE,0,D'2007.05.01 00:00:00'      ,DayMid);

   ObjectSet("DayMax"         ,OBJPROP_COLOR,Aqua);
   ObjectSet("DayMin"         ,OBJPROP_COLOR,Aqua);
   ObjectSet("DayMid"         ,OBJPROP_COLOR,White);

   ObjectSet("DayMax"         ,OBJPROP_STYLE,STYLE_DASH);
   ObjectSet("DayMin"         ,OBJPROP_STYLE,STYLE_DASH);
   ObjectSet("DayMid"         ,OBJPROP_STYLE,STYLE_DASH);
//------------------------------------------------------------------------------------
   ObjectCreate("DayMaxFix"         ,OBJ_HLINE,0,D'2007.05.01 00:00:00'    ,DayMax);
   ObjectCreate("DayMinFix"         ,OBJ_HLINE,0,D'2007.05.01 00:00:00'    ,DayMin);
   ObjectCreate("DayMidFix"         ,OBJ_HLINE,0,D'2007.05.01 00:00:00'    ,DayMid);

   ObjectSet   ("DayMaxFix"         ,OBJPROP_COLOR,Aqua);
   ObjectSet   ("DayMinFix"         ,OBJPROP_COLOR,Aqua);
   ObjectSet   ("DayMidFix"         ,OBJPROP_COLOR,White);
//-------------------------------------------------------------------------------------

   ObjectCreate("DayStart"          ,OBJ_VLINE,0,DayStart                    ,0     );
   ObjectCreate("DayEnd"            ,OBJ_VLINE,0,DayEnd                      ,0     );
   ObjectCreate("EurSesStart"       ,OBJ_VLINE,0,EurSesStart                 ,0     );
   ObjectCreate("UsaSesStart"       ,OBJ_VLINE,0,UsaSesStart                 ,0     );
   ObjectCreate("TradeEnd"          ,OBJ_VLINE,0,TradeEnd                    ,0     );
   
   ObjectSet("DayStart"             ,OBJPROP_COLOR,White);
   ObjectSet("DayEnd"               ,OBJPROP_COLOR,White);
   ObjectSet("EurSesStart"          ,OBJPROP_COLOR,White);
   ObjectSet("UsaSesStart"          ,OBJPROP_COLOR,White);
   ObjectSet("TradeEnd"             ,OBJPROP_COLOR,White);

   ObjectSet("DayStart"             ,OBJPROP_STYLE,Aqua);
   ObjectSet("DayEnd"               ,OBJPROP_STYLE,STYLE_DOT);
   ObjectSet("EurSesStart"          ,OBJPROP_STYLE,STYLE_DOT);
   ObjectSet("UsaSesStart"          ,OBJPROP_STYLE,STYLE_DOT);
   ObjectSet("TradeEnd"             ,OBJPROP_STYLE,STYLE_DOT);

//------------------------------------------------------------------------------------
   ObjectCreate("RangeMax"         ,OBJ_HLINE,0,D'2007.05.01 00:00:00'      ,RangeMax);
   ObjectCreate("RangeMin"         ,OBJ_HLINE,0,D'2007.05.01 00:00:00'      ,RangeMin);
   ObjectCreate("RangeMid"         ,OBJ_HLINE,0,D'2007.05.01 00:00:00'      ,RangeMid);

   ObjectSet("RangeMax"         ,OBJPROP_COLOR,Yellow);
   ObjectSet("RangeMin"         ,OBJPROP_COLOR,Gold);
   ObjectSet("RangeMid"         ,OBJPROP_COLOR,Gold);

   ObjectSet("RangeMax"         ,OBJPROP_STYLE,STYLE_SOLID);
   ObjectSet("RangeMin"         ,OBJPROP_STYLE,STYLE_SOLID);
   ObjectSet("RangeMid"         ,OBJPROP_STYLE,STYLE_DOT);
//------------------------------------------------------------------------------------
   ObjectCreate("RangeStart"             ,OBJ_VLINE,0,RangeStart                    ,0     );
   ObjectSet   ("RangeStart"             ,OBJPROP_COLOR,Gold);
   ObjectSet   ("RangeStart"             ,OBJPROP_STYLE,STYLE_DOT);
//-------------------------------------------------------------------------------------
return;
}
//------------------------------------------------------------------------------------ 
int  DayChanMove()
{
   ObjectMove("DayMax"  ,0,D'2007.05.01 00:00:00'      ,DayMax);
   ObjectMove("DayMin"  ,0,D'2007.05.01 00:00:00'      ,DayMin);
   ObjectMove("DayMid"  ,0,D'2007.05.01 00:00:00'      ,DayMid);
  
return;
}
//------------------------------------------------------------------------------------

